unit ldn176u1;

//Hardcoded for a drawing area of 620x620.. changing this
//  possible, but there are no error tests.

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  StdCtrls;

const
  bLedIndexMax=15;//If 15, there are *16* LEDs: 0,1,2.... 14,15
  bArrX=127;//if set to 63, there will be 64 elements
  bArrY=63;
  vers='18 Jul 18';  //Started: 18 Jul 18



type

  { TLDN176f1 }

  TLDN176f1 = class(TForm)
    Button1: TButton;
    buQuit: TButton;
    Button2: TButton;
    buByTimer: TButton;
    imgIm: TImage;
    Timer1: TTimer;
    procedure buQuitClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure buByTimerClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure DrawRect(iX,iY:integer;clDot:TColor);
    procedure Timer1Timer(Sender: TObject);
    procedure SchemeA;
  private
    bWhichLED:byte;
    clCellColor: array [0..bLedIndexMax] of TColor;
    iPosX: array [0..bLedIndexMax] of integer;
    iPosY: array [0..bLedIndexMax] of integer;
    procedure DrawAll;
    { private declarations }
  public
    { public declarations }
  end;

var
  LDN176f1: TLDN176f1;

implementation

{$R *.lfm}
{$R+}//turn on range checking... ("$R" is something ELSE}

var Bitmap:TBitmap;
  iImLeft,iImTop,iImWidth,iImHeight:integer;

{ TLDN176f1 }

//===========================================================
procedure TLDN176f1.FormCreate(Sender: TObject);
var c1: integer;
begin
  application.title:='LDN176';
  LDN176f1.caption:='LDN176, ver '+vers+' from sheepdogguides.com';

  LDN176f1.top:=20;
  LDN176f1.left:=20;

  bWhichLED:=0;

  //Establish SOMETHING in each array element...

  for c1:=0 to bLedIndexMax do
  begin
    clCellColor[c1]:=clRed;
    iPosX[c1]:=150;
    iPosY[c1]:=150;
  end;//for c1

  //Fine tune...

  clCellColor[0]:=clGreen;
  iPosX[0]:=150;
  iPosY[0]:=15;

(*  clCellColor[]:=clBlack;
  iPosX[]:=150;
  iPosY[]:=150;*)

  clCellColor[2]:=clBlack;
  iPosX[2]:=245;
  iPosY[2]:=50;

(*  clCellColor[]:=clBlack;
  iPosX[]:=150;
  iPosY[]:=150;*)

  clCellColor[4]:=clBlack;
  iPosX[4]:=290;
  iPosY[4]:=150;

(*  clCellColor[]:=clBlack;
  iPosX[]:=150;
  iPosY[]:=150;*)

  clCellColor[6]:=clBlack;
  iPosX[6]:=245;
  iPosY[6]:=255;

(*  clCellColor[]:=clBlack;
  iPosX[]:=150;
  iPosY[]:=150;*)

  clCellColor[8]:=clBlack;
  iPosX[8]:=150;
  iPosY[8]:=285;

(*  clCellColor[]:=clBlack;
  iPosX[]:=150;
  iPosY[]:=150;*)

  clCellColor[10]:=clBlack;
  iPosX[10]:=60;
  iPosY[10]:=255;

(*  clCellColor[]:=clBlack;
  iPosX[]:=150;
  iPosY[]:=150;*)

  clCellColor[12]:=clBlack;
  iPosX[12]:=15;
  iPosY[12]:=150;

(*  clCellColor[]:=clBlack;
  iPosX[]:=150;
  iPosY[]:=150;*)

  clCellColor[14]:=clBlack;
  iPosX[14]:=60;
  iPosY[14]:=50;

(*  clCellColor[]:=clBlack;
  iPosX[]:=150;
  iPosY[]:=150;*)

(*  clCellColor[]:=clBlack;
  iPosX[]:=150;
  iPosY[]:=150;*)

//Prepare drawing area...

  iImLeft:=imgIm.left;
  iImTop:=imgIm.top;
  iImWidth:=320;//imgIm.width;
  iImHeight:=320;//imgIm.height;
  imgIm.Width:=iImWidth;
  imgIm.Height:=iImHeight;


  if ((imgIm.Width<>320) OR
      (imgIm.Height<>320)) then
       showmessage('Size of hardcoded drawing area was changed. See code.');

  Bitmap:=TBitmap.create;
  Bitmap.width:=iImWidth;
  Bitmap.height:=iImHeight;

  imgIm.Canvas.pen.color:=clWhite;
  imgIm.Canvas.Rectangle(0,0,iImWidth,iImHeight);

  randomize;

end;//FormCreate

//===========================================================
procedure TLDN176f1.Button1Click(Sender: TObject);
var cX,cY: integer;
begin
showmessage('Button1 does nothing... yet. Revise code!');

DrawAll;
end;

procedure TLDN176f1.Button2Click(Sender: TObject);
var cX,cY: integer;
    bRedTmp,bGreenTmp,bBlueTmp:byte;
begin
  showmessage('Button2 does nothing... yet. Revise code!');

  DrawAll;

end;

procedure TLDN176f1.buByTimerClick(Sender: TObject);
begin
  if buByTimer.caption<>'Stop Timer' then
       begin
         buByTimer.caption:='Stop Timer';
         Timer1.enabled:=true;
       end// no ; here
     else
       begin
         buByTimer.caption:='Start Timer';
         Timer1.enabled:=false;
       end;//else
end;

procedure TLDN176f1.buQuitClick(Sender: TObject);
begin
  application.terminate;
end;

//===========================================================
procedure TLDN176f1.FormShow(Sender: TObject);
begin
  DrawAll;
end;//FormShow

//===========================================================
procedure TLDN176f1.DrawRect(iX,iY:integer;clDot:TColor);
var c1:byte;
  begin
    for c1:=0 to 8 do begin
    imgIm.Picture.Bitmap.canvas.pixels[iX+c1,iY]:=clDot;
    imgIm.Picture.Bitmap.canvas.pixels[iX+c1,iY+1]:=clDot;
    imgIm.Picture.Bitmap.canvas.pixels[iX+c1,iY+2]:=clDot;
    imgIm.Picture.Bitmap.canvas.pixels[iX+c1,iY+3]:=clDot;
    imgIm.Picture.Bitmap.canvas.pixels[iX+c1,iY+4]:=clDot;
    imgIm.Picture.Bitmap.canvas.pixels[iX+c1,iY+5]:=clDot;
    imgIm.Picture.Bitmap.canvas.pixels[iX+c1,iY+6]:=clDot;
    imgIm.Picture.Bitmap.canvas.pixels[iX+c1,iY+7]:=clDot;
    imgIm.Picture.Bitmap.canvas.pixels[iX+c1,iY+8]:=clDot;
    end;//for c1...
  end;//DrawRect

procedure TLDN176f1.Timer1Timer(Sender: TObject);
begin
  SchemeA;
end;

//===========================================================
procedure TLDN176f1.SchemeA;
begin
  clCellColor[bWhichLED]:=RGBToColor(random(255),random(255),random(255));
  bWhichLED:=bWhichLED+2;//chankge to "1" when all "LEDs" on circumfernece
  if bWhichLED>bLedIndexMax then bWhichLED:=0;

  DrawRect(iPosX[bWhichLED],iPosY[bWhichLED],clCellColor[bWhichLED]);
end;//SchemeA

//===========================================================
procedure TLDN176f1.DrawAll;
var c1: integer;
begin
    for c1:=0 to bLedIndexMax do
    begin
        DrawRect(iPosX[c1],iPosY[c1],clCellColor[c1]);
    end;//for cX
end;//DrawAll

end.

